import glibtop
import polling
import os

class Disk:

    def __init__(self):

        self.get_partitions = polling.wrap(self.__poll_partitions, 3)
        self.get_size = self.__poll_size



    def __poll_partitions(self):

        fd = os.popen("mount -p")
        data = fd.readlines()
        fd.close()

        partitions = []
        for lines in data:
           fields = lines.strip().replace("\t", " ").split()
           if (fields[2] in ("ext2", "ext3", "msdos", "vfat", "ntfs", "hpfs"
                          "jfs", "reiserfs", "xfs", "qnx4", "adfs", "ffs",
                          "hfs", "befs", "bfs", "efs", "iso9660", "minix",
                          "sysv", "coda", "nfs", "udf", "ufs", "xiafs")):
               partitions.append((fields[0], fields[1]))
        #end for

        return partitions



    def __poll_size(self, partition):

        blocks, bfree, bavail, files, ffree = glibtop.get_fsusage(partition)
        free = float(bfree * 512)
        total = float(blocks * 512)
        used = total - free

        return (total, used)
